/* default growth - this helps reducing the number of realloc() calls */
#define PATHGROW_GROW 256

typedef struct c99c_pathgrow_s {
	char *path;
	int alloced, used;
	char separator;
} c99c_pathgrow_t;

/* allocate an empty pathgrow */
c99c_pathgrow_t *c99c_pathgrow_alloc(char sep);

/* free all memory of a pathgrow, including p */
void c99c_pathgrow_free(c99c_pathgrow_t *p);

/* append a separator and a path item to the pathgrow */
void c99c_pathgrow_append(c99c_pathgrow_t *p, const char *item);

/* truncate last path item and a separator from the end of a pathgrow
   NOTE: does not shrink allocation! */
void c99c_pathgrow_truncate(c99c_pathgrow_t *p);
