/*
    c99tree - postprocess the tree
    Copyright (C) 2015  Tibor Palinkas

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include <stdlib.h>
#include "c99tree-cc.h"

static void postproc(c99c_node_t *root)
{
	c99c_node_t *n;
	for(n = root->children; n != NULL; n = n->next) {
		n->parent = root;

		/* bind twin parent: make sure connections are bidirectional */
		if ((n->loc.twin_parent != NULL)) {
			/* there may be multiple grammar_tree->token_tree binding; keep the
			innermost one and remove the rest */
			if ((n->loc.twin_parent->loc.twin_parent != NULL) && (root->type != T_TOKEN_TREE))
				n->loc.twin_parent->loc.twin_parent->loc.twin_parent = NULL;
			if (n->loc.twin_parent != NULL)
				n->loc.twin_parent->loc.twin_parent = n;
		}
		if (n->children != NULL)
			postproc(n);
	}
}

void c99c_tree_postproc(c99c_node_t *root)
{
	for(; root != NULL; root = root->next)
		postproc(root);
}
