#include <libporty/net/network.h>
#define dup2(a, b) printf("  DUP2  %d -> %d\n", a, b)
#define close(a)   printf("  CLOSE %d\n", a)

/* copied from bgproc code */
typedef enum ereason_e {
	BGPROC_EXITED,
	BGPROC_ABNORMAL, /* abnormal termination (segfault and things alike) */
	BGPROC_KILLED    /* was killed by term or kill */
} ereason_t;
typedef struct bgproc_status_s {
	ereason_t reason;
	int code;
} bgproc_status_t;
typedef int P_pid_t;
int children_created = 0;

static void watchdog_add(P_net_socket *ctrlfd, P_pid_t *pid, P_net_socket *chfd)
{

}

#include <libporty/net_async/abgproc_unix.c>
#include <assert.h>

void test(const char *name, char *s)
{
	P_net_socket pfds[1024];
	int cfds[1024];
	int n;

	printf("TEST %s: ", name);
	n = 0;
	do {
		int p, c, l, tokens;
		tokens = sscanf(s, "%d->%d%n", &p, &c, &l);
		assert((tokens == 2) || (tokens == 3));
		pfds[n] = p;
		cfds[n] = c;
		n++;
		s += l;
		printf("%d->%d ", p, c);
	} while(*s != '\0');
	printf("\n");

	P_net_async_bgproc_dupfds(pfds, cfds, n);
}

int main()
{
	test("leave-alone",                "1->1 2->2 3->3");
	test("leave-alone + inherit",      "1->1 2->2 3->3 4->6");
	test("reverse staircase",          "3->4 2->3 1->2");
	test("staircase",                  "1->2 2->3 3->4");
	test("swap",                       "1->2 2->1");
	test("1*circular",                 "1->2 2->3 3->4 4->1");
	test("2*circular",                 "1->2 2->3 3->4 4->1  5->6 7->8 8->7");

}
